Berkeley DB version 4.3.29

## com.sleepycat.bind.serial
Class TupleSerialKeyCreator

    java.lang.Object
      com.sleepycat.bind.serial.TupleSerialKeyCreator

All Implemented Interfaces:
  SecondaryKeyCreator

Direct Known Subclasses:
  TupleSerialMarshalledKeyCreator

public abstract class TupleSerialKeyCreator
extends Object
implements SecondaryKeyCreator

A abstract key creator that uses a tuple key and a serial data entry. This class takes care of serializing and deserializing the data entry, and converting the key entry to/from `TupleInput` and `TupleOutput` objects. The following abstract method must be implemented by a concrete subclass to create the index key using these objects

- `createSecondaryKey(TupleInput,Object,TupleOutput)`

Constructor Summary
`TupleSerialKeyCreator(ClassCatalog classCatalog, Class dataClass)` Creates a tuple-serial key creator.
`TupleSerialKeyCreator(SerialBinding dataBinding)` Creates a tuple-serial key creator.

Method Summary
`boolean` `createSecondaryKey(SecondaryDatabase db, DatabaseEntry primaryKeyEntry, DatabaseEntry dataEntry, DatabaseEntry indexKeyEntry)` Creates a secondary key entry, given a primary key and data entry.
`abstract boolean` `createSecondaryKey(TupleInput primaryKeyInput, Object dataInput, TupleOutput indexKeyOutput)` Creates the index key entry from primary key tuple entry and deserialized data entry.
`Object` `nullifyForeignKey(Object data)` Clears the index key in the deserialized data entry.
`boolean` `nullifyForeignKey(SecondaryDatabase db, DatabaseEntry dataEntry)`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TupleSerialKeyCreator

    public TupleSerialKeyCreator(ClassCatalog classCatalog,
                                 Class dataClass)

  Creates a tuple-serial key creator.

Parameters:
  `classCatalog` - is the catalog to hold shared class information and for a database should be a `StoredClassCatalog`.
  `dataClass` - is the data base class.

### TupleSerialKeyCreator

    public TupleSerialKeyCreator(SerialBinding dataBinding)

  Creates a tuple-serial key creator.

Parameters:
  `dataBinding` - is the data binding.

Method Detail

### createSecondaryKey

    public boolean createSecondaryKey(SecondaryDatabase db,
                                      DatabaseEntry primaryKeyEntry,
                                      DatabaseEntry dataEntry,
                                      DatabaseEntry indexKeyEntry)
                               throws DatabaseException

  Description copied from interface: `SecondaryKeyCreator`
  Creates a secondary key entry, given a primary key and data entry.

  Specified by:
    `createSecondaryKey` in interface `SecondaryKeyCreator`
  Parameters:
    `db` - the database to which the secondary key will be added.

    `primaryKeyEntry` - the primary key entry. This parameter must not be modified by this method.

    `dataEntry` - the primary data entry. This parameter must not be modified by this method.

    `indexKeyEntry` - the secondary key created by this method.

  Returns:
    true if a key was created, or false to indicate that the key is not present.

  Throws:
    `DatabaseException` - if an error occurs attempting to create the secondary key.

### nullifyForeignKey

    public boolean nullifyForeignKey(SecondaryDatabase db,
                                     DatabaseEntry dataEntry)
                              throws DatabaseException

  Throws:
    `DatabaseException`

### createSecondaryKey

    public abstract boolean createSecondaryKey(TupleInput primaryKeyInput,
                                               Object dataInput,
                                               TupleOutput indexKeyOutput)

  Creates the index key entry from primary key tuple entry and deserialized data entry.

  Parameters:
    `primaryKeyInput` - is the `TupleInput` for the primary key entry, or null if no primary key entry is used to construct the index key.
    `dataInput` - is the deserialized data entry, or null if no data entry is used to construct the index key.
    `indexKeyOutput` - is the destination index key tuple. For index keys which are optionally present, no tuple entry should be output to indicate that the key is not present or null.
  Returns:
    true if a key was created, or false to indicate that the key is not present.

### nullifyForeignKey

    public Object nullifyForeignKey(Object data)

  Clears the index key in the deserialized data entry.

  On entry the data parameter contains the index key to be cleared. It should be changed by this method such that `createSecondaryKey(com.sleepycat.db.SecondaryDatabase, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry)` will return false. Other fields in the data object should remain unchanged.

  Parameters:
    `data` - is the source and destination deserialized data entry.
  Returns:
    the destination data object, or null to indicate that the key is not present and no change is necessary. The data returned may be the same object passed as the data parameter or a newly created object.

Berkeley DB version 4.3.29

Copyright (c) 1996-2004 Sleepycat Software, Inc. - All rights reserved.